<?php

/**
 * Class to access MySQL DB
 * 
 * @author Epsilon <epsil_on@mail.ru>
 * @package UltimaPHP
 * @version 2.4.1
 *
 */
class uCoreDatabase {
	/**
	 * Link to current database connection
	 *
	 * @var object
	 */
	private $link;
	
	/**
	 * [DB] section of config.ini
	 *
	 * @var array
	 */
	private $db_config;
	
	/**
	 * Error code of last mysql operation
	 *
	 * @var integer
	 */
	public $errno;

	/**
	 * Error text of last mysql operation
	 *
	 * @var integer
	 */
	public $errtext;

	/**
	 * Method opens DB connection
	 *
	 * @param array(user,pass,host,port,name) $dbc
	 */
	function __construct($dbc) {

		$this->db_config = $dbc;
		// connect to server
		if (!($this->link = mysql_connect($dbc['host'].(is_numeric($dbc['port'])?(":".$dbc['port']):""), $dbc['user'], $dbc['pass']))) {
			trigger_error("MySQL server not found. Check DB configuration in ini file.", E_USER_ERROR);
		}
		// access to database
		if (!(@mysql_select_db ($dbc['name'], $this->link))) {
			trigger_error("Can not select MySQL database. Check DB configuration in the config file.", E_USER_ERROR);
		}
		$this->sql("set names 'utf8'");
	}

	/**
	 * Makes a sql query on current database
	 *
	 * @param string $query
	 * @return uDBQueryResult Result is array-accesible. In case of INSERT operation it returns inserted ID.
	 */
	public function sql($query, $converttoarray = true) {
		$res = @mysql_query($query, $this->link);
		$e_no = mysql_errno($this->link);
		$this->errno = $e_no;
		if ($e_no != 0) {
			$this->errtext = mysql_error($this->link);
			echo $query;
			trigger_error("(".$e_no.") ".mysql_error($this->link), E_USER_WARNING);
			$res = false;
		} else {
			$this->errtext = "";
			// Check if need to convert to array
			if (is_resource($res)) {
				// Valid. This is only test that $res is the MySQL-result.
					$ret = new uDBQueryResult($res);
			} else {
				if (substr(strtolower(ltrim($query)), 0, 6) == 'insert') {
					// Return insert_id
					$ret = mysql_insert_id($this->link);
				}
			}
		}
		unset($res);
		
		return $ret;
	}
}

class uDBQueryResult implements Iterator, Countable, ArrayAccess {
	
	protected $res = null;
	protected $position = 0;
	protected $num_rows = 0;
	protected $mysql_position = 0;
	
	function __construct($res) {
		$this->res = $res;
		$this->position = 0;
		$this->mysql_position = 0;
		$this->num_rows = mysql_num_rows($this->res);
	}
	
	function current() {
		if ($this->position != $this->mysql_position) {
			mysql_data_seek($this->res, $this->position);
			$this->mysql_position = $this->position;
		}
		$this->mysql_position ++;
		return mysql_fetch_assoc($this->res);
	}
	
	function key() {
		return $this->position;
	}
	
	function next() {
		$this->position ++;
	}
	
	function rewind() {
		$this->position = 0;
	}
	
	function valid() {
		return $this->position < $this->num_rows;
	}
	
	function count() {
		return $this->num_rows;
	}
	
	function offsetExists($offset) {
		return $offset < $this->num_rows;
	}
	
	function offsetUnset($offset) {
		throw new uAccessException('MySQL Result rows are read-only');
	}
	
	function offsetSet($offset, $value) {
		throw new uAccessException('MySQL Result rows are read-only');
	}
	
	function offsetGet($offset) {
		if ($offset < $this->num_rows) {
			if ($offset != $this->mysql_position) {
				mysql_data_seek($this->res, $offset);
				$this->mysql_position = $offset + 1;
			} else {
				$this->mysql_position ++;
			}
			return mysql_fetch_assoc($this->res);
		} else {
			return null;
		}
	}
	
	function asArray() {
		$r = array();
		foreach ($this as $d) {
			$r[] = $d;
		}
		
		return $r;
	}
}
